<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 1.22 $
 * $Author: tora60 $
 * $Date: 2011-12-29 00:23:16 $
 */

defined('mxMainFileLoaded') or die('access denied');

/**
 * Themesettingsdatei includen
 */
include(dirname(__FILE__) . '/settings.php');

/**
 * Dateiname des templates
 */
define('MX_THIS_THEMEFILE', 'theme.html');

/**
 * Standardfarben die im System und den Modulen verwendet werden
 */
global $bgcolor1;
$bgcolor1 = "#000000";
global $bgcolor2;
$bgcolor2 = "#292929";
global $bgcolor3;
$bgcolor3 = "#181818";
global $bgcolor4;
$bgcolor4 = "#292929";
global $textcolor1;
$textcolor1 = "#ffffff";
global $textcolor2;
$textcolor2 = "#ffffff";
// Modul-Bloecke im passenden Design anzeigen
/**
 * Design im pragmaMx.org Stil anzeigen
 */
$themePmxStyle = true;
/**
 * Breite der Tabelle im pragmaMx.org Stil
 */
$themePmxStyleWidth = '136px';

/**
 * Standardfarben der PopupFenster
 */
define("_ol_fgcolor", $bgcolor1); # Main background color (the large area). Usually a bright color (white, yellow etc)
define("_ol_textcolor", $textcolor1); # Text color. Usually a dark color
define("_ol_bgcolor", $bgcolor2); # Border color and color of caption. Usually a dark color (black, brown etc)
define("_ol_capcolor", $textcolor2); # Color of the caption text. Usually a bright color
define("_ol_closecolor", $textcolor2); # Color of "Close" when using Sticky. Usually a semi-bright color

/**
 * Definition der jeweiligen Platzhalter und deren Ersetzungen
 */
function theme_define_placeholders()
{
    global $themesetting;
    $part[] = array("{VIEWBENCH}", mxViewBench());
    $part[] = array("{FOOTMESSAGE}", theme_show_footmsg());
    $part[] = array("{DEBUGSERVICE}", theme_get_servicetext('debugservice'));
    $part[] = array("{SITESERVICE}", theme_get_servicetext('siteservice'));
    // $part[] = array("{LANGUAGEFLAGS}", theme_languageflags());
    $part[] = array("{CURRENTPATH}", theme_show_currentpath());
    $part[] = array("{SEARCHFORM}", mx_theme_searchform());
    $part[] = array("{LOGINFORM}", mx_theme_loginform());
    $part[] = array("{SHOWDATE}", theme_show_date());
    $part[] = array("{SHOWTIME}", theme_show_date());
    $part[] = array("{SHOWTOTALUSER}", theme_total_user_online());

    /* die Navigationsbuttons im header, Quelle in settings.php */
    foreach ($themesetting['headnav'] as $i => $link) {
        $part[] = array('{MENUITEM_' . $i . '}', '<a href="' . $link['link'] . '"><span>' . strtoupper($link['title']) . '</span></a>');
    }
    // Banner anzeigen
    // $part[] = array("{BANNER1}",   theme_show_banner(1)         ); #HeaderBanner
    // $part[] = array("{BANNER2}",   theme_show_banner(2)         ); #FooterBanner
    // $part[] = array("{BANNER7}",   theme_show_banner(7)         ); # Skyscraper
    // $part[] = array("{BANNER6}",   theme_show_banner(6)         ); # rechter Banner
    // weitere Beispiele dazu
    return $part;
}

/**
 * Definition der einzelnen Blockbereiche
 */
function theme_define_blocks()
{
    global $themesetting;
    static $var;
    if (isset($var)) return $var;
    // linke Bloecke
    $name = 'block_left';
    $var[$name]['container'] = 'blocks_left_loop';
    $var[$name]['function'] = 'themesidebox';
    $var[$name]['position'] = 'l';
    // provisorische Moeglichkeit, die linken Bloecke bei bestimmten Modulen zu entfernen
    if (isset($themesetting['noleft_modules']) && in_array(MX_MODULE, $themesetting['noleft_modules']) && MX_MODULE != 'admin') {
        unset($var[$name]);
    }
    // obere Center-Bloecke
    $name = 'block_center_top';
    $var[$name]['container'] = 'blocks_center_top_loop';
    $var[$name]['function'] = 'thememiddlebox';
    $var[$name]['position'] = 'c';
    // untere Center-Bloecke
    $name = 'block_center_down';
    $var[$name]['container'] = 'blocks_center_down_loop';
    $var[$name]['function'] = 'thememiddlebox';
    $var[$name]['position'] = 'd';
    // rechte Bloecke
    $name = 'block_right';
    $var[$name]['container'] = 'blocks_right_loop';
    $var[$name]['function'] = 'themesidebox';
    $var[$name]['position'] = 'r';
    return $var;
}

/**
 * Definition des Contentbereiches inkl. der open/close-Table Funktionen
 */
function theme_define_content()
{
    static $var;
    if (isset($var)) return $var;
    // die Funktion OpenTable()
    $var['opentabs']['OpenTable']['templatevar'] = 'opentable';
    $var['opentabs']['OpenTable']['innerreplace'] = '{OPENCLOSE_TABLE}'; // hier kann irgendwas stehen, es muss aber mit dem entsprechenden Text innerhalb der template-Datei uebereinstimmen...
    // die Funktion OpenTable2()
    $var['opentabs']['OpenTable2']['templatevar'] = 'opentable2';
    $var['opentabs']['OpenTable2']['innerreplace'] = '{OPENCLOSE_TABLE_2}';
    // die Funktion OpenTableAl()
    $var['opentabs']['OpenTableAl']['templatevar'] = 'opentableal';
    $var['opentabs']['OpenTableAl']['innerreplace'] = '{OPENCLOSE_TABLE_AL}';
    // die Funktion themeindex() / News Modul
    $var['themeindex'][1] = 'themeindex_1';
    $var['themeindex'][2] = 'themeindex_2'; // die Funktion themearticle() beim 2ten Aufruf / News Modul
    // die Funktion themearticle() / News Modul
    $var['themearticle'] = 'themearticle';
    // der Name (output_container) darf nicht veraendert werden !!
    $var['output_container'] = 'script_output';
    // der Name (index_on_container) darf nicht veraendert werden !!
    $var['index_on_container'] = 'blocks_right_container';
    $var['index_on_block_container'] = 'blocks_right_loop';
    // der Name (more_header) darf nicht veraendert werden !!
    $var['add_header'] = 'more_header';

    return $var;
}

/**
 * ersetzen von eigenen Theme-Elementen, kann veraendert und ergaenzt werden
 * diese Teile werden gleich zu Beginn des scriptes, beim einlesen des templates, ersetzt
 * Vorsicht, wenn das Theme gecached werden soll!!!
 * Dann duerfen hier keine dynamischen Elemente eingesetzt werden.
 */
function theme_replace_start($template)
{
    /**
     * bestimmte Texte, vor allem Image-Pfade, die ersetzt werden sollen, definieren (suche/ersetze)
     */
    $part[] = array('"style/', '"' . MX_THEME_DIR . '/style/'); // die Stylesheets
    $part[] = array('"images/', '"' . MX_THEME_DIR . '/images/'); // normale images im theme
    $part[] = array('"js/', '"' . MX_THEME_DIR . '/js/');
    $part[] = array('url(images/', 'url(' . MX_THEME_DIR . '/images/');
    return theme_replace_parts($template, $part);
}

/**
 * ersetzen von eigenen Theme-Elementen, kann veraendert und ergaenzt werden
 * diese Teile werden vor der Ausgabe des headers im Headbereich ersetzt
 */
function theme_replace_header($newheader)
{
    return $newheader;
    // alles ersetzen und Rckgabe...
    // return theme_replace_parts($newheader, $part);
}

/**
 * ersetzen in jedem einzelnen Block
 */
function theme_replace_blocks($template, $block)
{
    /*
    switch ($block['position']) {
        case 'l':
            break;
        case 'c':
            break;
        case 'd':
            break;
        case 'r':
            break;
    }
    */

    /* Teil fuer alle Bloecke */
    if (empty($block['title']) || $block['title'] == 'NOTITLE') {
        $part[] = array('__BLOCK_ID__' , '__BLOCK_ID__ block-hide-caption');
    }
    $part[] = array('__BLOCK_ID__' , 'block-' . $block['position'] . '-' . $block['order']);

    if (isset($part)) {
        return theme_replace_parts($template, $part);
    }
    return $template;
}

/**
 * ersetzen von eigenen Theme-Elementen, kann veraendert und ergaenzt werden
 * diese Teile werden am Ende des scriptes, in der Funktion themefooter() ersetzt
 */
function theme_replace_end($template)
{
    global $themesetting;
    // je nach $index, die Tabellenspalten der rechten Bloecke extrahieren oder entfernen
    if (empty($GLOBALS['index'])) {
        $part[] = array('<div id="centercolumn">', '<div id="centercolumn1">');
    }
    // provisorische Moeglichkeit, die linken Bloecke bei bestimmten Modulen zu entfernen
    if (isset($themesetting['noleft_modules']) && in_array(MX_MODULE, $themesetting['noleft_modules']) && MX_MODULE != 'admin') {
        theme_extract_part($template, 'blocks_left_container');
        $part[] = array('<div id="centercolumn1">', '<div id="centercolumnfull">');
    }
    // leere Tabellen Tags entfernen, wenn kein Inhalt von Modul angezeigt wird (blank_home)
    if (isset($part)) {
        return theme_replace_parts($template, $part);
    }
    return $template;
}

/**
 * Anzeige der Sprach-Flaggen,
 * aber begrenzt auf die in den theme-Settings definierten Sprachen
 */
function theme_languageflags()
{
    global $themesetting;
    if (isset($themesetting['languagelist'])) {
        return theme_show_languageflags($themesetting['languagelist']);
    } else {
        return theme_show_languageflags();
    }
}

/**
 * Die Navigationsbuttons in der Artikelliste des Newsmoduls
 */
function getThemeIndexButtons($story)
{
    global $theme_template;
    static $img, $isnewsadmin;
    if (!isset($isnewsadmin)) {
        $isnewsadmin = mxGetAdminPref('radminarticle');
    }
    if (empty($img)) {
        // die images werden in einen statischen Variable gehalten um die Bildgroessen nicht bei jedem Artikel zu ermitteln
        // xx als alttext wird weiter unten dynamisch ersetzt
        $img[1] = mxCreateImage(MX_THEME_DIR . '/images/buttons/informant.gif', 'xx', array('title' => 'xx'));
        $img[2] = mxCreateImage(MX_THEME_DIR . '/images/buttons/print.gif', _BMXPRINTER, array('title' => _BMXPRINTER));
        $img[3] = mxCreateImage(MX_THEME_DIR . '/images/buttons/friend.gif', _BMXFRIEND, array('title' => _BMXFRIEND));
        $img[4] = mxCreateImage(MX_THEME_DIR . '/images/buttons/counter.gif', 'xx', array('title' => 'xx'));
        $img[6] = mxCreateImage(MX_THEME_DIR . '/images/buttons/bytesmore.gif', 'xx', array('title' => 'xx'));
        if ($GLOBALS['articlecomm']) $img[5] = mxCreateImage(MX_THEME_DIR . '/images/buttons/comments.gif', 'xx', array('title' => 'xx'));
        // mxdebugfuncvars($story['allmorelink']); // zum ansehen der morelink-Parameter einkommentieren
        // mxdebugfuncvars($story);                // zum ansehen der story-Parameter der ersten story einkommentieren
    }
    // mxdebugfuncvars($story);                  // zum ansehen der story-Parameter aller stories einkommentieren
    $bmore = ($story['allmorelink']['bodycount']) ? _READMORE . " (" . $story['allmorelink']['bodycount'] . ' ' . _BYTESMORE . ")" : _READMORE;
    $adminlink = ($isnewsadmin) ? " href='admin.php?op=EditStory&amp;sid=" . $story['sid'] . "' " : "";
    $link[] = $story['allmorelink']['storylink'] . str_replace("xx", $bmore, $img[6]) . "</a>";
    if ($story['informant'] != $GLOBALS['anonymous'] && (MX_IS_USER || MX_IS_ADMIN)) {
        $link[] = $story['allmorelink']['informantlink'] . str_replace("xx", _USERINFO . ": " . $story['informant'], $img[1]) . "</a>";
    }
    $link[] = $story['allmorelink']['printerlink'] . $img[2] . "</a>";
    if (mxModuleAllowed('Recommend_Us')) {
        $link[] = $story['allmorelink']['friendlink'] . $img[3] . "</a>";
    }
    if (empty($story['acomm']) && $GLOBALS['articlecomm']) { // Achtung!!! acomm: 0 = Ja , 1 = Nein
        $link[] = $story['allmorelink']['commentslink'] . str_replace("xx", _COMMENTS . " (" . $story['comments'] . ")", $img[5]) . "</a>";
    }
    $link[] = "<a title='" . $story['allmorelink']['counter'] . ", " . $story['allmorelink']['score'] . "' " . $adminlink . ">" . str_replace("xx", $story['counter'] . ' ' . _READS, $img[4]) . "</a>";
    return $link;
}

/**
 * Beschreibung
 */
function mx_theme_searchform()
{
    $out = '';
    if (mxModuleAllowed('Search')) {
        $out = '
<form action="modules.php" method="get" title="' . _SEARCH . '">
<input type="hidden" name="name" value="Search">
<input type="text" name="query" size="20" title="' . _SEARCH . '">
<input type="submit" value="' . _SEARCH . '" title="' . _SEARCH . '">
</form>
';
    }
    return $out;
}

/**
 * Beschreibung
 */
function mx_theme_loginform()
{
    global $prefix, $user_prefix, $JPCACHE_ON;
    if ($JPCACHE_ON) {
        return;
    }
    $out = "";
    if (!MX_IS_USER) {
        if (!defined("mxloginblockviewed")) define("mxloginblockviewed", true);
        $nickname = _NICKNAME;
        $password = _PASSWORD;
        $login = _LOGIN;
        $check = mxGetUserLoginCheckField();
        $out .= <<<logform
<form action="modules.php?name=Your_Account" method="post">
$check
  <table align="center" border="0" cellspacing="0" cellpadding="1">
    <tbody>
      <tr>
        <td>$nickname:</td>
        <td><div align="left">
            <input type="text" name="uname" size="14" maxlength="25" title="$nickname">
          </div></td>
      </tr>
      <tr>
        <td><div align="left">$password:</div></td>
        <td><div align="left">
            <input type="password" name="pass" size="14" maxlength="20" title="$password">
          </div></td>
      </tr>
      <tr>
        <td colspan="2" align="center"><div align="left">
            <input name="submit" type="submit" value="$login">
          </div></td>
      </tr>
    </tbody>
  </table>

</form>
logform;
    } else {
        $hallo = _HELLO;
        $logout = _AB_LOGOUT;
        $account = _YACCOUNT;
        $privatemessages = "";
        $username = mxSessionGetVar('user_uname');
        // private Nachrichten
        if (mxModuleAllowed('Private_Messages')) { // falls pm-modul aktiv ist
            $qry = "SELECT Count(msg_id) FROM ${prefix}_priv_msgs WHERE to_userid=" . (int)mxSessionGetVar('user_uid') . " AND read_msg=0;";
            $result = sql_query($qry);
            list($countpmunread) = sql_fetch_row($result);
            if ($countpmunread) { // wenn angemeldeter User
                $privatemessages = "<div style=\"text-align: left;\">" . _YOUHAVE . " <a href=\"modules.php?name=Private_Messages\" title=\"" . _PRIVATEMSG . "\"><b style=\"color: #99cc33; font-weight: bold;\">" . intval($countpmunread) . "</b>&nbsp;Nachricht(en)</a></div>";
            }
        }
        // Usergaestebuch
        $guestbook = "";
        $arrowpic = mxCreateImage(MX_THEME_DIR . '/images/arrow.gif', '');
        $out .= <<<logform
$hallo <span style="color: #99cc33; background-color: transparent;">$username</span> !
<br /><br />

$privatemessages $guestbook
  <table align="left" width="100%" border="0">
  <tr>
    <td>$arrowpic</td>
    <td><a href="modules.php?name=Your_Account" title="$account">Account</a></td>
    <td>$arrowpic</td>
    <td><a href="modules.php?name=Your_Account&amp;op=logout" title="$logout">Logout</a></td>
  </tr>
</table>
logform;
    }
    return $out;
}

